Foreman - Bug #33647

GraphQL response should return valid attribute values
10/06/2021 02:24 PM - Ondfej Prazak

Status: Closed
Priority: Normal
Assignee: Ondrej Prazak
Category: API
Target version:
Difficulty: Fixed in Releases: 3.1.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/8819
Description

When we are updating models via GraphQL, we assign new attribute values to the model and save (BaseMutation#save_object).
If there are validation errors, the model with invalid attribute values is used for response. This is causing problems in Ul with as
Apollo detects a change in an attribute and places the new (invalid) value into its cache. To leverage Apollo's automatic cache
updates, we should return the persisted value, not the assigned and invalid.

Steps to reproduce:

variables = { id: model_global_id, name: '' }

mutation UpdateModelMutation ($id: ID!, $name: String) {
updateModel (input: { id: $id, name: S$name }) {

model {
id
name

t

errors {
path
message

}
}
Expected Result:

{
updateModel {
model {
id: 'very_long_global_id',
name: 'My model'

by

errors: [{
path: ["attributes", "name"],
message: "can't be blank"

H
}
}

Actual Result:
updateModel {
model {

id: 'very_long_global_id',
name: ''
}I
errors: [{
path: ["attributes", "name"],
message: "can't be blank"
H
}

Associated revisions

Revision d0f5a61b - 10/08/2021 08:47 AM - Ondfej Prazak

Fixes #33647 - Return persisted attrs on edit mutation

History

#1 - 10/06/2021 02:30 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ondrej PraZzak

- Pull request https://github.com/theforeman/foreman/pull/8819 added

#2 - 10/08/2021 08:47 AM - The Foreman Bot
- Fixed in Releases 3.1.0 added

#3 - 10/08/2021 09:01 AM - Ondfej Prazak
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|d0f5a61bf61b3300f687{219f3c1bb15d06e0d98.

#4 - 11/15/2021 04:44 PM - Amit Upadhye
- Category set to API
